<?php
/* Copyright (C) 2020 - 2021		Christophe Battarel	<christophe.battarel@altairis.fr>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 * Need to have following variables defined:
 * $object (invoice, order, ...)
 * $conf
 * $langs
 * $seller, $buyer
 * $dateSelector
 * $forceall (0 by default, 1 for supplier invoices/orders)
 * $senderissupplier (0 by default, 1 for supplier invoices/orders)
 * $inputalsopricewithtax (0 by default, 1 to also show column with unit price including tax)
 */

$nbrows=ROWS_2;
if (! empty($conf->global->MAIN_INPUT_DESC_HEIGHT)) $nbrows=$conf->global->MAIN_INPUT_DESC_HEIGHT;
$enable= (isset($conf->global->FCKEDITOR_ENABLE_DETAILS)?$conf->global->FCKEDITOR_ENABLE_DETAILS:0);
$toolbarname='dolibarr_details';
if (! empty($conf->global->FCKEDITOR_ENABLE_DETAILS_FULL)) $toolbarname='dolibarr_notes';
if (! defined('REQUIRE_CKEDITOR')) define('REQUIRE_CKEDITOR', '1');

if (! empty($conf->global->FCKEDITOR_SKIN)) {
	$skin = $conf->global->FCKEDITOR_SKIN;
} else {
	$skin = 'moono-lisa'; // default with ckeditor 4.6 : moono-lisa
}

?>

<script type="text/javascript">

function htmlEscape(s) {
	return (s + '')
		// commented by christophe battarel.replace(/&/g, '&amp;')
		// commented by christophe battarel.replace(/</g, '&lt;')
		// commented by christophe battarel.replace(/>/g, '&gt;')
		.replace(/'/g, '&#039;')
		.replace(/"/g, '&quot;')
		// commented by christophe battarel.replace(/\n/g, '<br />')
		;
}


function stripHtmlEntities(text) {
	return text.replace(/&.*?;/g, '');
}

function toggle_desc(a) { // TODO : TESTER SI CKEDITOR OU NON
	if ($(a).attr("altaview") == "hidden") {
		var name = $(a).attr("name").replace("showdesc", "");
		var desc = $('input[name=product_desc' + name +']').val();
		desc = stripHtmlEntities(desc);
		$('input[name=product_desc' + name +']').remove();
		$(a).after('<span id="spandesc' + name + '"><br><br><textarea id="product_desc' + name + '" name="product_desc' + name + '" rows="<?php echo $nbrows; ?>" style="margin-top: 4px; width: 300px; height: 80px;" class="flat">' + desc +  '</textarea></span>');

		<?php if ($enable) { // $conf->global->FCKEDITOR_ENABLE_DETAILS ?>
		CKEDITOR.replace("product_desc" + name, {
			customConfig : ckeditorConfig,
			skin : '<?php echo $skin; ?>',
			toolbar : '<?php echo $toolbarname; ?>',
			language: '<?php echo $langs->defaultlang; ?>',
			textDirection: '<?php echo $langs->trans("DIRECTION"); ?>',
			on :
					{
						instanceReady : function( ev )
						{
							// Output paragraphs as <p>Text</p>.
							this.dataProcessor.writer.setRules( 'p',
								{
									indent : false,
									breakBeforeOpen : true,
									breakAfterOpen : false,
									breakBeforeClose : false,
									breakAfterClose : true
								});
						},

						change : function()
						{
							this.updateElement();
							$("form#draftedit").data("changed",true);
							$("a.draftchanged").show();
						}
					}
		});

		<?php } ?>

		$(a).attr("altaview", "shown");
	}
	else {
		$(a).attr("altaview", "hidden");
		var name = $(a).attr("name").replace("showdesc", "");
		var desc = $('textarea[name=product_desc' + name +']').val();
		desc = htmlEscape(desc);

		<?php if ($enable) { // $conf->global->FCKEDITOR_ENABLE_DETAILS ?>

			CKEDITOR.instances['product_desc' + name].destroy();

		<?php } ?>

		$('span#spandesc' + name).remove();
		$(a).after('<input type="hidden" id="product_desc' + name + '" name="product_desc' + name + '" value="' + desc + '" />');
	}
}

<?php
if (! empty($conf->stock->enabled) && empty($senderissupplier))
{
?>
	// [name] is the name of the event "click", "mouseover", ..
	// same as you\'d pass it to bind()
	// [fn] is the handler function
	$.fn.bindFirst = function(name, fn) {
		// bind as you normally would
		// don\'t want to miss out on any jQuery magic
		this.on(name, fn);

		// Thanks to a comment by @Martin, adding support for
		// namespaced events too.
		this.each(function() {
			var handlers = $._data(this, "events")[name.split(".")[0]];
			// take out the handler we just inserted from the end
			var handler = handlers.pop();
			// move it at the beginning
			handlers.splice(0, 0, handler);
		});
	};

	function checkQtyStock(e)
	{
		var tr = $(this).parents("tr:first");

		if ( ! $("input[name^=options_rental_line]",tr).prop("checked")
		&& ($(e.relatedTarget).parents("tr:first").is(tr) || e.which == 1)
		&& ( typeof $(e.relatedTarget).attr("id") == "undefined" || $(e.relatedTarget).attr("id") != 'cancellinebutton')
		&& ( typeof $(e.relatedTarget).attr("name") == "undefined" || $(e.relatedTarget).attr("name") != 'search_idprod')
		&& ( typeof $(e.relatedTarget).attr("name") == "undefined" || ! $(e.relatedTarget).attr("name").startsWith('options_rental_line'))
		&& ( typeof $(e.relatedTarget).attr("name") == "undefined" || ! $(e.relatedTarget).attr("name").startsWith('options_used_line'))
		&& ( typeof $(e.relatedTarget).attr("name") == "undefined" || ! $(e.relatedTarget).attr("name").startsWith('sel_')) // for relatedproducts
		&& ($("[name^=options_used_line]",tr).val() == "1"
			<?php
			if ( ! empty($conf->global->DOLITOOLS_CHECK_QTY_IN_STOCK) ) {
			?>
				|| $("input[name^=onpurchase]",tr).val() == "0"
			<?php
			}
			?>
			)
		&& $("input[name^=qty]",tr).val() * 1 > 0
		&& $("input[name^=qty]",tr).val() * 1 > $("input[name^=stock_available]",tr).val() * 1
		<?php
		if ( empty($conf->global->STOCK_SUPPORTS_SERVICES) ) {
		?>
				&& $("input[name^=type]",tr).val() == 0
		<?php
		}
		?>
		)
		{
			e.stopImmediatePropagation();

			$("input[name^=qty]",tr).focus().select();

			alert("<?php echo $langs->trans("QtyNotInStock"); ?>");

			return false;
		}

	}

	$(document).ready(function()
	{
		$("table").on("blur", "input[name^=qty]", checkQtyStock);
		$("input#addline").bindFirst("click", checkQtyStock);
	});
<?php
}
if (! empty($showmargins) && $user->rights->margins->creer)
{
?>

	/* Some js test when we click on button "Add" */
	$(document).ready(function() {
		<?php
		if (! empty($conf->global->DISPLAY_MARGIN_RATES)) { ?>
			$("input[name^='np_marginRate']").change(function(e) {
				var tr = $(this).parents("tr:first");
				return checkFreeLine(e, "np_marginRate", tr);
			});
		<?php
		}
		if (! empty($conf->global->DISPLAY_MARK_RATES)) { ?>
			$("input[name^='np_markRate']").change(function(e) {
				var tr = $(this).parents("tr:first");
				return checkFreeLine(e, "np_markRate", tr);
			});
		<?php
		}
		?>
	});

	/* TODO This does not work for number with thousand separator that is , */
	function checkFreeLine(e, npRate, tr)
	{
		var buying_price = $("input[name^='buying_price']", tr);
		var remise = $("input[name^='remise_percent']", tr);

		var rate = $("input[name='"+npRate+"']", tr);
		if (rate.val() == '')
			return true;

		var ratejs = price2numjs(rate.val());
		if (! $.isNumeric(ratejs))
		{
			alert('<?php echo dol_escape_js($langs->trans("rateMustBeNumeric")); ?>');
			e.stopPropagation();
			setTimeout(function () { rate.focus() }, 50);
			return false;
		}
		if (npRate == "np_markRate" && rate.val() >= 100)
		{
			alert('<?php echo dol_escape_js($langs->trans("markRateShouldBeLesserThan100")); ?>');
			e.stopPropagation();
			setTimeout(function () { rate.focus() }, 50);
			return false;
		}

		var price = 0;
		remisejs=price2numjs(remise.val());

		if (remisejs != 100)	// If a discount not 100 or no discount
		{
			if (remisejs == '') remisejs=0;

			bpjs=price2numjs(buying_price.val());
			ratejs=price2numjs(rate.val());

			if (npRate == "np_marginRate")
				price = ((bpjs * (1 + ratejs / 100)) / (1 - remisejs / 100));
			else if (npRate == "np_markRate")
				price = ((bpjs / (1 - ratejs / 100)) / (1 - remisejs / 100));
		}
		$("input[name^='price_ht']", tr).val(price).change();	// TODO Must use a function like php price to have here a formated value

		return true;
	}

<?php
}
?>
$(document).ready(function()
{
	// delegation events binding will cause dynamically created elements to get the binding !
	$("table").on("change", "input[name^=price_ht]", function(event) {
		var tr = $(this).parents("tr:first");
		if ($("input[name^=options_rental_line]", tr).prop("checked")) return;
			var price_ht = price2numjs($(this).val());
			if ($("select[name^=tva_tx]", tr).length > 0) {
				var tva_tx = price2numjs($("select[name^=tva_tx]", tr).val());
				$("input[name^=price_ttc]", tr).val(price_ht * (1 + tva_tx / 100));
			}
			var remise_percent = price2numjs($("input[name^=remise_percent]", tr).val());
			var discounted = price_ht * (1 - remise_percent / 100);
			$("input[name^=discounted_price]", tr).val(discounted);
			var qty = $("input[name^=qty]", tr).val();
			$("td.linecolht", tr).text(discounted * qty);
			$("input[name^=multicurrency_subprice]", tr).val('');
	});

	$("table").on("change", "input[name^=discounted_price]", function(event) {
		var tr = $(this).parents("tr:first");
		if ($("input[name^=options_rental_line]", tr).prop("checked")) return;
			var pxrem = price2numjs($(this).val());
			var price_ht = price2numjs($("input[name^=price_ht]", tr).val());
			if (price_ht != 0) $("input[name^=remise_percent]", tr).val(((price_ht - pxrem) / price_ht) * 100);
			$("input[name^=multicurrency_subprice]", tr).val('');
	});

	$("table").on("change", "input[name^=remise_percent]", function(event) {
		var tr = $(this).parents("tr:first");
		if ($("input[name^=options_rental_line]", tr).prop("checked")) return;
			var remise_percent = price2numjs($(this).val());
			var price_ht = price2numjs($("input[name^=price_ht]", tr).val());
			$("input[name^=discounted_price]", tr).val(price_ht * (1 - remise_percent / 100));
			$("input[name^=multicurrency_subprice]", tr).val('');
	});

	$("table").on("change", "[name^=tva_tx]", function(event) {
		var tr = $(this).parents("tr:first");
			var price_ht = price2numjs($("input[name^=price_ht]", tr).val());
			var tva_tx = price2numjs($(this).val());
			$("input[name^=price_ttc]", tr).val(price_ht * (1 + tva_tx / 100));
	});

	$("table").on("change", "input[name^=price_ttc]", function(event) {
		var tr = $(this).parents("tr:first");
		// console.log(event.which);		// discard event tag and arrows
			var price_ttc = price2numjs($(this).val());
			var tva_tx = price2numjs($("[name^=tva_tx]", tr).val());
			if (parseFloat(tva_tx) == 0) $("input[name^=price_ht]", tr).val(price_ttc).change();
			else $("input[name^=price_ht]", tr).val(price_ttc / (1 + tva_tx / 100)).change();
			$("input[name^=multicurrency_subprice]", tr).val('');
	});

	$("table").on("change", "input[name^=multicurrency_subprice]", function(event) {
		var tr = $(this).parents("tr:first");
		// console.log(event.which);		// discard event tag and arrows
			$("input[name^=price_ht]", tr).val('');
			$("input[name^=price_ttc]", tr).val('');
			$("input[name^=discounted_price]", tr).val('');
	});

    <?php
    if (! empty($conf->margin->enabled))
    {
    ?>
		/* Add rule to clear margin when we change some data, so when we change sell or buy price, margin will be recalculated after submitting form */
		$("table").on("click", "[name^=tva_tx]", function(event) {
			var tr = $(this).parents("tr:first");
			$("input[name^='np_marginRate']", tr).val('');
			$("input[name^='np_markRate']", tr).val('');
		});
		$("table").on("keyup", "[name^=tva_tx]", function(event) {
			var tr = $(this).parents("tr:first");
			$("input[name^='np_marginRate']", tr).val('');
			$("input[name^='np_markRate']", tr).val('');
		});
		$("table").on("keyup", "[name^=price_ht]", function(event) {
			var tr = $(this).parents("tr:first");
			$("input[name^='np_marginRate']", tr).val('');
			$("input[name^='np_markRate']", tr).val('');
		});
		$("table").on("keyup", "[name^=qty]", function(event) {
			var tr = $(this).parents("tr:first");
			$("input[name^='np_marginRate']", tr).val('');
			$("input[name^='np_markRate']", tr).val('');
		});
		$("table").on("keyup", "[name^=remise_percent]", function(event) {
			var tr = $(this).parents("tr:first");
			$("input[name^='np_marginRate']", tr).val('');
			$("input[name^='np_markRate']", tr).val('');
		});
		$("table").on("keyup", "[name^=buying_price]", function(event) {
			var tr = $(this).parents("tr:first");
			$("input[name^='np_marginRate']", tr).val('');
			$("input[name^='np_markRate']", tr).val('');
		});

    <?php
    }
    ?>
});

function getSupplierPrice(idprod, tr)
{
	$("[name^=fournprice]", tr).find("option").remove();
	$("[name^=fournprice]", tr).hide();
	<?php
	if (! empty($user->rights->margins->creer) && !empty($conf->global->ALTATPL_SHOW_MARGIN_INFOS))
	{
	?>
		$("[name^=buying_price]", tr).val("").show();
	<?php
	}
	?>
	/* Call post to load content of combo list fournprice_predef */
	var token = '<?php echo currentToken(); ?>';		// For AJAX Call we use old 'token' and not 'newtoken'
	$.post("<?php echo dol_buildpath('/fourn/ajax/getSupplierPrices.php', 1); ?>?bestpricefirst=1", { 'idprod': idprod, 'token': token }, function(data) {
		if (data && data.length > 0)
		{
			var options = ''; var defaultkey = ''; var defaultprice = ''; var bestpricefound = 0;

			var bestpriceid = 0; var bestpricevalue = 0;
			var pmppriceid = 0; var pmppricevalue = 0;
			var costpriceid = 0; var costpricevalue = 0;

			/* setup of margin calculation */
			var defaultbuyprice = '<?php
			if (isset($conf->global->MARGIN_TYPE))
			{
				if ($conf->global->MARGIN_TYPE == '1')   print 'bestsupplierprice';
				if ($conf->global->MARGIN_TYPE == 'pmp') print 'pmp';
				if ($conf->global->MARGIN_TYPE == 'costprice') print 'costprice';
			} ?>';
			console.log("we will set the field for margin. defaultbuyprice="+defaultbuyprice);

			var i = 0;
			$(data).each(function() {
				var label = "";
				<?php
				if (!empty($conf->global->ALTATPL_FOURNREF_ON_PRICELIST))
				{ ?>
					label = this.label;
				<?php
				}
				else
				{ ?>
					var pos = this.label.indexOf(' (');
					if (pos > 0) label = this.label.substr(0,pos);
					else label = this.label;
				<?php
				} ?>
				if (this.id != 'pmpprice' && this.id != 'costprice')
				{
					i++;
					this.price = parseFloat(this.price); // to fix when this.price >0
					// If margin is calculated on best supplier price, we set it by defaut (but only if value is not 0)
					//console.log("id="+this.id+"-price="+this.price+"-"+(this.price > 0));
					if (bestpricefound == 0 && this.price > 0) { defaultkey = this.id; defaultprice = this.price; bestpriceid = this.id; bestpricevalue = this.price; bestpricefound=1; }	// bestpricefound is used to take the first price > 0
				}
				if (this.id == 'pmpprice')
				{
					// If margin is calculated on PMP, we set it by defaut (but only if value is not 0)
					//console.log("id="+this.id+"-price="+this.price);
					if ('pmp' == defaultbuyprice || 'costprice' == defaultbuyprice)
					{
						if (this.price > 0) {
							defaultkey = this.id; defaultprice = this.price; pmppriceid = this.id; pmppricevalue = this.price;
							//console.log("pmppricevalue="+pmppricevalue);
						}
					}
				}
				if (this.id == 'costprice')
				{
					// If margin is calculated on Cost price, we set it by defaut (but only if value is not 0)
					//console.log("id="+this.id+"-price="+this.price+"-pmppricevalue="+pmppricevalue);
					if ('costprice' == defaultbuyprice)
					{
						if (this.price > 0) { defaultkey = this.id; defaultprice = this.price; costpriceid = this.id; costpricevalue = this.price; }
						else if (pmppricevalue > 0) { defaultkey = pmppriceid; defaultprice = pmppricevalue; }
					}
				}
				options += '<option value="'+this.id+'" price="'+this.price+'">'+label+'</option>';
			});
			options += '<option value="inputprice" price="'+defaultprice+'"><?php echo $langs->trans("InputPrice"); ?></option>';

			console.log("finally selected defaultkey="+defaultkey+" defaultprice="+defaultprice);

			$("[name^=fournprice]", tr).html(options).show();
			if (defaultkey != '')
			{
				$("[name^=fournprice]", tr).val(defaultkey);
			}

			/* At loading, no product are yet selected, so we hide field of buying_price */
			$("[name^=buying_price]", tr).hide();

			/* Define default price at loading */
			var defaultprice = $("[name^=fournprice]", tr).find('option:selected').attr("price");
			$("[name^=buying_price]", tr).val(defaultprice);

			$("[name^=fournprice]", tr).change(function() {
				console.log("change on fournprice_predef");
				/* Hide field buying_price according to choice into list (if 'inputprice' or not) */
				var linevalue=$(this).find('option:selected').val();
				var pricevalue = $(this).find('option:selected').attr("price");
				if (linevalue != 'inputprice' && linevalue != 'pmpprice') {
					$("[name^=buying_price]", tr).val(pricevalue).hide();	/* We set value then hide field */
				}
				if (linevalue == 'inputprice') {
					$("[name^=buying_price]", tr).show();
				}
				if (linevalue == 'pmpprice') {
					$("[name^=buying_price]", tr).val(pricevalue);
					$("[name^=buying_price]", tr).hide();
				}
			});
		}
		else $("[name^=buying_price]", tr).val(0);
	},
	'json');

}

</script>
