<?php
/* Copyright (C) 2012-2022	Christophe Battarel <christophe.battarel@altairis.fr>
 * Copyright (C) 2022		Noé Cendrier		<noe.cendrier@altairis.fr>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Library javascript to enable display effects
 */

if (!defined('NOREQUIRESOC'))  define('NOREQUIRESOC', '1');
if (!defined('NOCSRFCHECK')) define('NOCSRFCHECK', 1);
if (!defined('NOTOKENRENEWAL')) define('NOTOKENRENEWAL', 1);
if (!defined('NOLOGIN')) define('NOLOGIN', 1);
if (!defined('NOREQUIREMENU')) define('NOREQUIREMENU', 1);
if (!defined('NOREQUIREHTML')) define('NOREQUIREHTML', 1);
if (!defined('NOREQUIREAJAX')) define('NOREQUIREAJAX', '1');

/**
 * \file    dolitools/js/dolitools.js.php
 * \ingroup dolitools
 * \brief   JavaScript file for module Dolitools.
 */

$res=@include("../../main.inc.php");					// For root directory
if (! $res) $res=@include("../../../main.inc.php");		// For "custom" directory

// Define javascript type
top_httphead('text/javascript; charset=UTF-8', 1);
// Important: Following code is to avoid page request by browser and PHP CPU at each Dolibarr page access.
if (empty($dolibarr_nocache)) header('Cache-Control: max-age=10800, public, must-revalidate');
else header('Cache-Control: no-cache');
?>
$(document).ready(function() {

	<?php
	if ( ! empty($conf->global->ALTATHEME_COLORIZE_SELECTED_LINES))
	{?>
		$("div.fiche > table.liste > tbody > tr:not('.liste_titre'), div.fiche > form > table.liste > tbody > tr:not('.liste_titre'), div.fiche > form > div.div-table-responsive > table.liste > tbody > tr:not('.liste_titre')").click(function() {
			$(this).toggleClass("active");
		});
	<?php
	}?>

<?php if ( ! empty($conf->global->DOLITOOLS_USE_ALTATHEME) &&  (! empty($conf->global->ALTATHEME_USE_STICKY_HEADER) || ! empty($conf->global->ALTATHEME_FIX_CARD_HEADER) || ! empty($conf->global->ALTATHEME_FIX_TABLE_HEADERS)))
{?>

		resize_header();

<!--
	$(window).resize(function() {

		resize_header();
	});
-->
<?php
}?>

});

<?php if ( ! empty($conf->global->DOLITOOLS_USE_ALTATHEME) && (! empty($conf->global->ALTATHEME_USE_STICKY_HEADER) || ! empty($conf->global->ALTATHEME_FIX_CARD_HEADER) || ! empty($conf->global->ALTATHEME_FIX_TABLE_HEADERS)))
{?>

function resize_header()
{
		if ($("div.fiche table#tablelines").length > 0)
		{
			var w = $("div.fiche table#tablelines").outerWidth(true) + $("div.fiche table#tablelines").offset().left;
			//w = Math.max(w, $("div.fiche").outerWidth(true) + $("div.fiche").offset().left - $("div.side-nav-vert").offset().left);

			if (w > $("div.side-nav-vert").css("width").replace('px', '')) $("div.side-nav-vert").css("width", w);
		}
		else if ($("div.fiche > table.liste").length > 0)
		{
			var w = $("div.fiche > table.liste").outerWidth() + $("div.fiche > table.liste").offset().left + $("div.side-nav-vert").offset().left;
			//w = Math.max(w, $("div.fiche").outerWidth(true) + $("div.fiche").offset().left - $("div.side-nav-vert").offset().left);

			if (w > $("div.side-nav-vert").css("width").replace('px', '')) $("div.side-nav-vert").css("width", w);
		}
		else if ($("div.fiche > form > table.liste").length > 0)
		{
			var w = $("div.fiche> form > table.liste").outerWidth(true) + $("div.fiche> form > table.liste").offset().left - $("div.side-nav-vert").offset().left;
			//w = Math.max(w, $("div.fiche").outerWidth(true) + $("div.fiche").offset().left - $("div.side-nav-vert").offset().left);
			if (w > $("div.side-nav-vert").css("width").replace('px', '')) $("div.side-nav-vert").css("width", w);
		}
		else if ($("div.fiche > form > div.div-table-responsive > table.liste").length > 0)
		{
			var w = $("div.fiche > form > div.div-table-responsive > table.liste").outerWidth(true) + $("div.fiche > form > div.div-table-responsive > table.liste").offset().left  - $("div.side-nav-vert").offset().left;
			//w = Math.max(w, $("div.fiche").outerWidth(true) + $("div.fiche").offset().left - $("div.side-nav-vert").offset().left);
			if (w > $("div.side-nav-vert").css("width").replace('px', '')) $("div.side-nav-vert").css("width", w);
		}
		else if ($("div.fiche").length > 0)
		{
			//var w = $("div.fiche").outerWidth(true) + $("div.fiche").offset().left - $("div.side-nav-vert").offset().left;

			//if (w > $("div.side-nav-vert").css("width").replace('px', '')) $("div.side-nav-vert").css("width", w);
		}
		<?php
		if (! empty($conf->global->ALTATHEME_USE_STICKY_HEADER) && ! empty($conf->global->ALTATHEME_FIX_CARD_HEADER))
		{
		?>
			$("div.arearef").css("top", $("div.side-nav-vert").height());
		<?php
		}
		?>
}
<?php
}

if ( ! empty($conf->global->DOLITOOLS_USE_ALTATHEME))
{?>
$(document).ready(function() {
	/* remember if side menu is collapsed */
	var hidden = sessionStorage.getItem("sidebar-collapsed");
	if (hidden == "true") {
		$("body").addClass("sidebar-collapse");
	}
	$("li.menuhider").click(function(event) {
		hidden = (hidden == "true" ? false : true);
		sessionStorage.setItem("sidebar-collapsed", hidden);
	});
});
<?php
}
